(**************************************************************************)
(*                                                                        *)
(*  This file is part of Frama-C.                                         *)
(*                                                                        *)
(*  Copyright (C) 2007-2009                                               *)
(*    CEA (Commissariat  l'nergie Atomique)                             *)
(*                                                                        *)
(*  you can redistribute it and/or modify it under the terms of the GNU   *)
(*  Lesser General Public License as published by the Free Software       *)
(*  Foundation, version 2.1.                                              *)
(*                                                                        *)
(*  It is distributed in the hope that it will be useful,                 *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU Lesser General Public License for more details.                   *)
(*                                                                        *)
(*  See the GNU Lesser General Public License version 2.1                 *)
(*  for more details (enclosed in the file licenses/LGPLv2.1).            *)
(*                                                                        *)
(**************************************************************************)

module Cb = struct
  include ViewGraph.EmptyCb
  let button_one_press_on_node _env _n = () 
      (* TODO : show fct in source viewer ? *)
  let button_two_press_on_node _env _n = ()
      (* TODO : show calls in source viewer ? *)
end

module V = ViewGraph_select.VG (Cb)

let show_cg_cb _a = 
  let cg_name = Options.Filename.get () in
  let cg_name = 
    if cg_name <> "" then cg_name
    else Filename.temp_file "framaC_cg_" ".dot"
  in 
  Options.Filename.set cg_name;
  let select_init_env = ViewGraph_utils.create_graph_win "Call Graph" in
    Format.printf "[call graph] preparing the file %s " cg_name;
    !Db.Syntactic_Callgraph.dump ();
    Format.printf "done.";
  try
    let env = () in
    let _graph = V.open_dot_file env select_init_env cg_name in
      ()
  with ViewGraph.DotError _ ->
    GToolbox.message_box "Error"
      (Printf.sprintf "Didn't succed to build graph for %s\nSorry !" cg_name)

let main window =
  GAction.add_actions window#actions 
    [GAction.add_action "CallGraph" ~label:"_Show Call Graph" ~callback:show_cg_cb];
    window#ui_manager#add_ui_from_string
      "<ui><menubar name='MenuBar'> 
              <menu action='ViewMenu'>
                 <menuitem action='CallGraph'/> 
              </menu>
           </menubar>
       </ui>";
  ()

let () = Design.register_extension main

(*
Local Variables:
compile-command: "LC_ALL=C make -C ../.."
End:
*)

